/**
 **	Database.C
 **
 **	Published / author: 2001-02-15 / grymse@telia.com
 **/

/*
Copyright (C) 2001  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql/mysql.h>
/*
#ifdef THREAD_SAFE
#ifdef USE_SDL
#include <SDL.h>
#else
#include <pthread.h>
#endif // USE_SDL
#endif // THREAD_SAFE
*/
#include "Database.h"

#define DEB(x) 


Database::Database(void)
{
/*
#ifdef THREAD_SAFE
#ifdef USE_SDL
	m_lock = SDL_CreateMutex();
#else
	pthread_mutex_init(&m_mutex, NULL);
#endif // USE_SDL
#endif // THREAD_SAFE
*/
}


Database::Database(const std::string& h,const std::string& u,const std::string& p,const std::string& d)
:host(h) //new char[strlen(h) + 1])
,user(u) //new char[strlen(u) + 1])
,password(p) //new char[strlen(p) + 1])
,database(d) //new char[strlen(d) + 1])
{
/*
#ifdef THREAD_SAFE
#ifdef USE_SDL
	m_lock = SDL_CreateMutex();
#else
	pthread_mutex_init(&m_mutex, NULL);
#endif // USE_SDL
#endif // THREAD_SAFE
	strcpy(host,h);
	strcpy(user,u);
	strcpy(password,p);
	strcpy(database,d);
*/
	freedb(grabdb());		// open one connection
}


Database::~Database(void)
{
/*
	OPENDB *odb;

	if (host)
	{
		delete host;
	}
	if (user)
	{
		delete user;
	}
	if (password)
	{
		delete password;
	}
	if (database)
	{
		delete database;
	}
*/
/*
#ifdef THREAD_SAFE
	MutexLock();
#endif
*/
	for (opendb_v::iterator it = m_opendbs.begin(); it != m_opendbs.end(); it++)
	{
		OPENDB *p = *it;
		mysql_close(&p -> mysql);
	}
/*
	for (odb = opendbbase; odb; odb = odb -> next)
	{
		mysql_close(&odb -> mysql);
	}
*/
	while (m_opendbs.size())
	{
		opendb_v::iterator it = m_opendbs.begin();
		OPENDB *p = *it;
		if (p -> busy)
		{
			fprintf(stderr,"destroying Database object before Connect object(s)\n");
		}
		delete p;
		m_opendbs.erase(it);
	}
/*
	while (opendbbase)
	{
		odb = opendbbase;
		opendbbase = opendbbase -> next;
		if (odb -> busy)
		{
			fprintf(stderr,"destroying Database object before Connect object(s)\n");
		}
		delete odb;
	}
*/
/*
#ifdef THREAD_SAFE
	MutexUnlock();
#endif
#ifdef THREAD_SAFE
#ifdef USE_SDL
	SDL_DestroyMutex(m_lock);
#else
	pthread_mutex_destroy(&m_mutex);
#endif // USE_SDL
#endif // THREAD_SAFE
*/
}

Database::OPENDB *Database::grabdb(void)
{
	OPENDB *odb = NULL;
DEB(	int q = 0;)

#ifdef THREAD_SAFE
	MutexLock();
#endif
	for (opendb_v::iterator it = m_opendbs.begin(); it != m_opendbs.end(); it++)
	{
		odb = *it;
		if (!odb -> busy)
		{
			break;
		}
		else
		{
			odb = NULL;
		}
DEB(		q++;)
	}
/*
	for (odb = opendbbase; odb; odb = odb -> next)
	{
		if (!odb -> busy)
		{
			break;
		}
DEB(		q++;)
	}
*/
	if (!odb)
	{
		odb = new OPENDB;
		if (!mysql_init(&odb -> mysql))
		{
			fprintf(stderr,"mysql_init() failed\n");
//			errc = 1;
		}
		if (!mysql_connect(&odb -> mysql,host.c_str(),user.c_str(),password.c_str()))
		{
			fprintf(stderr,"mysql_connect(%s,%s,***) failed\n",host.c_str(),user.c_str());
//			errc = 2;
		}
		if (mysql_select_db(&odb -> mysql,database.c_str()))
		{
			fprintf(stderr,"mysql_select_db(%s,%s,%s,%s) failed\n",host.c_str(),user.c_str(),password.c_str(),database.c_str());
//			errc = 3;
		}
		odb -> busy = true;
		m_opendbs.push_back(odb);
//		odb -> next = opendbbase;
//		opendbbase = odb;
DEB(		q++;
		fprintf(stderr,"Database::grabdb():  %d handle%s in use\n",q,(q == 1) ? "" : "s");)
	}
	else
	{
		odb -> busy = true;
	}
#ifdef THREAD_SAFE
	MutexUnlock();
#endif
	return odb;
}


void Database::freedb(Database::OPENDB *odb)
{
	odb -> busy = false;
}


/*
short Database::errcode(void)
{
	return errc;
}


void Database::debug(short val)
{
	_debug = val;
}


short Database::debug(void)
{
	return _debug;
}
*/
