/**
 **	Database.h
 **
 **	Published / author: 2001-02-15 / grymse@telia.com
 **/

/*
Copyright (C) 2001  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _DATABASE_HH
#define _DATABASE_HH

#include <string>
#include <vector>
/*
typedef struct opendbstruct
{
	struct opendbstruct *next;
#ifdef _mysql_h
	MYSQL mysql;
#endif
	short busy;
} OPENDB;
*/


class Database 
{
public:
	struct OPENDB {
		OPENDB() : busy(false) {}
		MYSQL mysql;
		bool busy;
	};
	typedef std::vector<OPENDB *> opendb_v;
public:
	Database(void);
//	Database(char *h,char *u,char *p,char *d);
	Database(const std::string& host,
		 const std::string& user,
		 const std::string& password = "",
		 const std::string& database = "");
	~Database(void);

	OPENDB *grabdb(void);
	void freedb(OPENDB *odb);
//	short errcode(void);
//	void debug(short val);
//	short debug(void);

private:
	std::string host;
	std::string user;
	std::string password;
	std::string database;
//	OPENDB *opendbbase;
	opendb_v m_opendbs;
//	short errc;
//	short _debug;
/*
#ifdef THREAD_SAFE
#ifdef USE_SDL
	SDL_mutex *m_lock;
	void MutexLock() {
		SDL_mutexP(m_lock);
	}
	void MutexUnlock() {
		SDL_mutexV(m_lock);
	}
#else
	pthread_mutex_t m_mutex;
	void MutexLock() {
		pthread_mutex_lock(&m_mutex);
	}
	void MutexUnlock() {
		pthread_mutex_unlock(&m_mutex);
	}
#endif // USE_SDL
#endif // THREAD_SAFE
*/
};

#endif // _DATABASE_HH
