/**
 **	Query.H
 **
 **	Published / author: 2001-02-15 / grymse@telia.com
 **/

/*
Copyright (C) 2001  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _QUERY_HH
#define _QUERY_HH

#include <string>


class Query {
public:
	Query(Database *dbin);
	Query(Database& dbin);
	Query(Database *dbin,char *sql);
	Query(Database& dbin,const std::string& sql);
	~Query();

	short execute(const std::string& sql);

// methods using db specific api calls

	MYSQL_RES *get_result(const std::string& sql);
	void free_result();
	MYSQL_ROW fetch_row();
	long insert_id();
	long num_rows();

// data retreival methods

	const char *getstr(int x);
	const char *getstr();
	double getnum(int x);
	long getval(int x);
	double getnum();
	long getval();
	double get_num(const std::string& sql);
	long get_count(const std::string& sql);
	const char *get_string(const std::string& sql);

//MYSQL_FIELD *	STDCALL mysql_fetch_field(MYSQL_RES *result);

	MYSQL_FIELD *fetch_field();
	const char *fetch_fieldname();

	std::string safestr(const std::string& );
	std::string unsafestr(const std::string& );
	std::string xmlsafestr(const std::string& );

private:
	Database& m_db;
	Database::OPENDB *odb;
#ifdef _mysql_h
	MYSQL_RES *res;
	MYSQL_ROW row;
#endif
	short rowcount;
};


#endif // _QUERY_HH
